# Documentation
require 'pry'
require_relative 'playable'
require_relative 'treasure_trove'
module StudioGame
  class Player
    include Playable
    attr_accessor :name, :health

    def initialize(name, health = 100)
      @name = name.capitalize
      @health = health
      @found_treasures = Hash.new(0)
    end

    def to_csv
      "#{name},#{points}"
    end

    def self.from_csv(line)
      name, health = line.split(',')
      health = health.nil? ? 100 : health
      Player.new(name, Integer(health))
    end

    def to_s
      "I'm #{@name} with health = #{@health}, points = #{points}, and score = #{score}."
    end

    def found_treasure(tresure)
      puts "#{@name} found a #{tresure.name} worth #{tresure.points} points."
      @found_treasures[tresure.name] += tresure.points
      puts "#{@name}'s treasures: #{@found_treasures}."
      tresure
    end

    def each_found_treasure
      @found_treasures.each do |name, worth|
        yield Treasure.new(name, worth)
      end
    end

    def points
      @found_treasures.values.reduce(0, :+)
    end
  end
end

if __FILE__ == $PROGRAM_NAME
  player = Player.new('moe')
  puts player.name
  puts player.health
  player.w00t
  puts player.health
  player.blam
  puts player.health
end
